unit DelayTestf;

interface

uses
  RSCOM, Controls, Classes, Windows, Messages, SysUtils, Graphics, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    ScrollBar1: TScrollBar;
    LabelTime: TLabel;
    ButtonTest1: TButton;
    ButtonTest2: TButton;
    LabelTime1: TLabel;
    LabelTime2: TLabel;
    procedure ButtonTest1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ButtonTest2Click(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}


procedure TForm1.FormCreate(Sender: TObject);
begin
  OpenCOM ('COM2');
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  LabelTime.Caption := IntToStr(ScrollBar1.Position) + ' us';
end;

procedure TForm1.ButtonTest1Click(Sender: TObject);
var N: Integer;
    T: Real;
begin
  RealTime;
  TimeInit;
  T := ScrollBar1.Position / 1000;
  For N := 1 to 500 do begin
    DTR (1);
    Delay (T);
    DTR (0);
    Delay (T);
  end;
  T := TimeRead;
  NormalTime;
  LabelTime1.Caption := FloatToStr(T) + ' ms'
end;

procedure TForm1.ButtonTest2Click(Sender: TObject);
var N: Integer;
    T: Real;
begin
  RealTime;
  TimeInit;
  T := ScrollBar1.Position / 1000;
  For N := 1 to 500 do begin
    DTR (1);
    While TimeRead < (2*N-1)*T Do;
    DTR (0);
    While TimeRead < (2*N)*T Do;
   end;
  T := TimeRead;
  NormalTime;
  LabelTime2.Caption := FloatToStr(T) + ' ms'
end;

end.
