
#if !defined(AFX_DAQEXAMPLEDLG_H__7C5B5B89_1B80_4B18_BE51_019212615106__INCLUDED_)
#define AFX_DAQEXAMPLEDLG_H__7C5B5B89_1B80_4B18_BE51_019212615106__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif

#include "Parameter.h"

#define OK                   0
#define NICHT_OK             1

#define RECHENBEREIT         2
#define NICHT_RECHENBEREIT   3

class CDAQExampleDlg : public CDialog
{
   public:
	   CDAQExampleDlg(CWnd* pParent = NULL);

	   //{{AFX_DATA(CDAQExampleDlg)
	   enum { IDD = IDD_DAQEXAMPLE_DIALOG };
	   CString	m_Edit;
	   //}}AFX_DATA

	   //{{AFX_VIRTUAL(CDAQExampleDlg)
	   protected:
	      virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung
	   //}}AFX_VIRTUAL

      HANDLE OpenComm ( LPCSTR port, UINT cbInQueue, UINT cbOutQueue );
      int FlushComm ( HANDLE hComm, int fnQueue );
      int CloseComm ( HANDLE hComm );

      BOOL Create_VxD_Sys ();
      BOOL Close_VxD_Sys ();
      int SCAN_Start ( WORD wBaseAddress, UINT iNo, WORD iChannelPos[6], UINT count, UINT ms );
      int DAQ_HalfReady ( BOOL *bHalfReady, BOOL *bDAQstopped );
      int DAQ_Transfer ( DWORD *mprVal );
      int DAQ_Clear ( );

      int Init();
      int Fetch();
      int Execute();
      int Done();

      void SchalteControlFeldAus ( UINT ControlFeld[40] );
		void SchalteControlFeldEin ( UINT ControlFeld[40] );

      HANDLE m_hCVxDSys;
      UINT m_ms;
      UINT m_count;
      WORD m_iChannelPos[6];
      BOOL m_bComIDProblem;

      DWORD *mprVal;

   protected:
      CParameter m_Param;
	   BOOL m_Running;
	   HMODULE m_Lib;
	   HICON m_hIcon;
	   UINT m_Timer;

	   //{{AFX_MSG(CDAQExampleDlg)
	   virtual BOOL OnInitDialog();
	   afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	   afx_msg void OnPaint();
	   afx_msg HCURSOR OnQueryDragIcon();
	   afx_msg void OnStart();
	   afx_msg void OnStop();
	   afx_msg void OnParam();
	   afx_msg void OnTimer(UINT nIDEvent);
	   //}}AFX_MSG
	   DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}

#endif // !defined(AFX_DAQEXAMPLEDLG_H__7C5B5B89_1B80_4B18_BE51_019212615106__INCLUDED_)
