unit SFRf;

interface

uses
  RSCOM, Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    ButtonCOM1: TRadioButton;
    ButtonCOM2: TRadioButton;
    EditAdr: TEdit;
    EditDat: TEdit;
    WrSFR: TButton;
    RdSFR: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ButtonCOM2Click(Sender: TObject);
    procedure ButtonCOM1Click(Sender: TObject);
    procedure WrSFRClick(Sender: TObject);
    procedure RdSFRClick(Sender: TObject);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  if (OpenCom ('COM2:9600,N,8,1') = 0) then
     ButtonCOM1.Checked := True;
end;



procedure TForm1.ButtonCOM2Click(Sender: TObject);
begin
  CloseCOM;
  if OpenCom ('COM2:9600,N,8,1') = 0 then
     ShowMessage ('COM Error');
end;

procedure TForm1.ButtonCOM1Click(Sender: TObject);
begin
 CloseCOM;
  if OpenCom ('COM1:9600,N,8,1') = 0 then
     ShowMessage ('COM Error');
end;
function HexToInt (Hexzahl: String): Byte;
var h, l: Byte;
begin
  h:= ord (Hexzahl[1]);
  if h>96 then h := h-32;  {Kleinschreibung}
  h:= h-48;
  if h>9 then h:=h-7;
  if h<0 then h:=0;
  if h>15 then h:=15;
  l:= ord (Hexzahl[2]);
  if l>96 then l := l-32;  {Kleinschreibung}
  l:= l-48;
  if l>9 then l:=l-7;
  if l<0 then l:=0;
  if l>15 then l:=15;
  Result := 16*h+l;
end;

function ByteToHex (Dat: Integer): String;
var   Hi, Lo: Integer;
      LoHex, HiHex: String;
begin
  Lo := Dat and 15;
  Hi := Dat div 16;
  if Hi > 9 then Hi := Hi + 7;
  HiHex := Chr (48+Hi);
  if Lo > 9 then Lo := Lo + 7;
  LoHex := Chr (48+Lo);
  Result := HiHex + LoHex;
end;


procedure TForm1.WrSFRClick(Sender: TObject);
begin
  Sendbyte (1);
  Sendbyte (HexToInt(EditAdr.Text));
  Sendbyte (HexToInt(EditDat.Text));
end;

procedure TForm1.RdSFRClick(Sender: TObject);
begin
  Sendbyte (2);
  Sendbyte (HexToInt(EditAdr.Text));
  EditDat.Text := ByteToHex (ReadByte);
end;

end.
